clc;clear;close all;
% Applied function: arz_sta_noise_spectrum.m | arz_zp.m
%% Parameters
fs = 1000; %sampling rate
N  = 1024; %points
zp = N;    %points of zero-padding

t  = [1:N]/fs; % time
dt = t(2)-t(1);% time interval
f  = 49; % frequency
dr = -0.5;     % decay rate
SNR=20;% signal to noise ratio

stacking_num = 30;
Q = [];

%% generate signal
x =  exp(dr.*t).*(sin(2*pi*f*t));
xr = awgn(x,SNR,0,40); %wgn/randn also can add noise

%% calculate Arz spectrum
[F,spectrum]=arz_sta_noise_spectrum(xr,dt,Q,N,SNR,stacking_num);

%% plot
figure
plot(F,spectrum./max(spectrum))
xlabel('Frequency');ylabel('Amp');
title('AR-z Spectrum')
%% cirtcle point
[gg1,rr1,ff1,dist1,poles1,unc1]=arz_zp(x,dt,N,Q);
[gg2,rr2,ff2,dist2,poles2,unc2]=arz_zp(xr,dt,N,Q);

figure
subplot(211)
plot(real(unc1),imag(unc1),'b.');hold on
scatter(real(poles1),imag(poles1),'r');
title('original signal')
axis([-1.2,1.2,0,1.2])

subplot(212)
plot(real(unc2),imag(unc2),'b.');hold on
scatter(real(poles2),imag(poles2),'r');
title('add noise')
axis([-1.2,1.2,0,1.2])

