clc;clear;close all;
% Applied function: mt4pi.m | mtcoh.m
%% test signal
fs = 2000;
f1 = 93;
f2 = 150;
t  = 0:1/fs:1-1/fs;
N  = length(t);
x  =  sin(2*pi*f1*t)+0.5*wgn(1,N,0,1,1);
y  =  sin(2*pi*f1*t+pi/3)+sin(2*pi*f2*t)+0.5*wgn(1,N,0,1,2);

% frequency axis
df    = fs/N;
faxis = [0:df:df*(N-1)];
F     = faxis(1:N/2);

%% multitaper  cacluate tapers with input data x
figure;
v=mt4pi(x); 
title("tapers");

%% coherence between x and y signal with v tapers
% phase +, x is earlier than y
[coh,~]=mtcoh(x,y,v);
figure;
subplot(211);plot(F,abs(coh).^2);title('Coherence');ylabel('Coherence Magnitude Squared');xlabel('Frequency')
subplot(212);plot(F,angle(coh).*180./pi);title('Phase');ylabel('Coherence Phase (in degree)');xlabel('Frequency')
return
