% This program computes the 4pi-multitapered (in v splined from v199 using
% "mtinterp" first!) coherence spectrum of real-valued time 
% series x and y of length n.
% The coherence spectrum is complex-valued, so:
% abs(coh).^2 gives the squared-coherence, and angle(coh) gives the
% phase angle.
%
% format: function coh=mtcoh(datax,datay,v)
%
function [coh,sx]=mtcoh(datax,datay,v)
%check the vector size
[a,b]=size(datax);
[c,d]=size(datay);
if b>a
    datax=datax';
end
if d>c
    datay=datay';
end

n=length(datax);
m=7;
disp('fft coherence...')
sxx=zeros(n,1);
syy=sxx;
ssxy=sxx+i*sxx;
for j=1:m
   sx=fft(v(:,j).*datax);
   sy=fft(v(:,j).*datay);
   sxy=sx.*conj(sy);
   sx=sx.*conj(sx);
   sy=sy.*conj(sy);
   sxx=sxx+sx;
   syy=syy+sy;
   ssxy=ssxy+sxy;
end
n1=ceil(n/2);
sxx=sxx(1:n1);
syy=syy(1:n1);
ssxy=ssxy(1:n1);
coh=ssxy./sqrt((sxx.*syy));

